function accept(this)
%ACCEPT overload the java.net.ServerSocket accept method
%
%   ACCEPT(THIS) or alternatively THIS.ACCEPT is executed once the object
%   has been bound to an address. This method waits for a connection from a
%   client socket and then continuously accepts commands from the client,
%   executes them and returns the results to the client.
%
%   INPUTS:
%       THIS  : instance of the simple.ServerSocket class
%
%   See Also: simple.Socket

    % use the superclass accept
    this.socket = handle(this.java.accept);

    % infinate loop use ctrl-c to exit
    while 1
        % wait for a command then execute it capturing output
        while this.socket.getInputStream.available < 2
        end
        
        msb = this.socket.getInputStream.read;
        lsb = this.socket.getInputStream.read;
        
        numChar = 256 * msb + lsb;
        cmd = uint8(zeros(1, numChar));
        
        for index = 1:numChar
            cmd(index) = this.socket.getInputStream.read;
        end
        result = evalc(char(cmd));
        
        % send the result back to the calling system
        len = numel(result);
        msb = uint8(floor(len/256));
        lsb = uint8(mod(len,256));
        
        this.socket.getOutputStream.write(uint8([msb, lsb, result]));
    end
end
